"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  fastifyFetch: () => fastifyFetch
});
module.exports = __toCommonJS(src_exports);

// node_modules/.pnpm/data-uri-to-buffer@4.0.1/node_modules/data-uri-to-buffer/dist/index.js
function dataUriToBuffer(uri) {
  if (!/^data:/i.test(uri)) {
    throw new TypeError('`uri` does not appear to be a Data URI (must begin with "data:")');
  }
  uri = uri.replace(/\r?\n/g, "");
  const firstComma = uri.indexOf(",");
  if (firstComma === -1 || firstComma <= 4) {
    throw new TypeError("malformed data: URI");
  }
  const meta = uri.substring(5, firstComma).split(";");
  let charset = "";
  let base64 = false;
  const type = meta[0] || "text/plain";
  let typeFull = type;
  for (let i = 1; i < meta.length; i++) {
    if (meta[i] === "base64") {
      base64 = true;
    } else if (meta[i]) {
      typeFull += `;${meta[i]}`;
      if (meta[i].indexOf("charset=") === 0) {
        charset = meta[i].substring(8);
      }
    }
  }
  if (!meta[0] && !charset.length) {
    typeFull += ";charset=US-ASCII";
    charset = "US-ASCII";
  }
  const encoding = base64 ? "base64" : "ascii";
  const data = unescape(uri.substring(firstComma + 1));
  const buffer = Buffer.from(data, encoding);
  buffer.type = type;
  buffer.typeFull = typeFull;
  buffer.charset = charset;
  return buffer;
}
var dist_default = dataUriToBuffer;

// src/fastify-fetch.ts
var import_fastify_plugin = __toESM(require("fastify-plugin"));
var import_undici = require("undici");
var import_util = require("util");
var import_zlib = require("zlib");
var gunzip = (0, import_util.promisify)(import_zlib.gunzip);
var brotliDecompress = (0, import_util.promisify)(import_zlib.brotliDecompress);
var inflate = (0, import_util.promisify)(import_zlib.inflate);
var supportedSchemas = /* @__PURE__ */ new Set(["data:", "http:", "https:"]);
var decompressPayload = async (rawPayload, headers) => {
  if (rawPayload.length === 0) {
    return void 0;
  }
  const codings = headers.get("content-encoding")?.toLowerCase().split(",").map((x) => x.trim()) ?? [];
  if (codings.length === 0) {
    return rawPayload;
  }
  const decoders = [];
  const remainingCodings = codings.map((coding) => {
    if (/(x-)?gzip/.test(coding)) {
      decoders.push(async (value) => await gunzip(value));
    } else if (/(x-)?deflate/.test(coding)) {
      decoders.push(async (value) => await inflate(value));
    } else if (coding === "br") {
      decoders.push(async (value) => await brotliDecompress(value));
    } else {
      return coding;
    }
    return void 0;
  }).filter((value) => value !== void 0);
  decoders.push(async (value) => await Promise.resolve(value));
  const payload = await decoders.reduce(
    (previousValue, currentValue) => async (value) => await currentValue(await previousValue(value))
  )(rawPayload);
  if (remainingCodings.length === 0) {
    headers.delete("content-encoding");
  } else {
    headers.set("content-encoding", Array.from(remainingCodings).join(", "));
  }
  return payload;
};
var fastifyFetch = (0, import_fastify_plugin.default)(async (app, options = {}) => {
  const hasMatchFunction = typeof options.match === "function";
  app.decorate(
    "fetch",
    async (requestInfo, requestInit) => {
      const request = new import_undici.Request(requestInfo, requestInit);
      const parsedURL = new URL(request.url);
      if (!supportedSchemas.has(parsedURL.protocol)) {
        throw new TypeError(
          `URL scheme "${parsedURL.protocol.replace(
            /:$/,
            ""
          )}" is not supported.`
        );
      }
      if (parsedURL.protocol === "data:") {
        const data = dist_default(request.url);
        return new import_undici.Response(data, {
          headers: { "Content-Type": data.typeFull }
        });
      }
      const method = request.method.toUpperCase();
      if (!["DELETE", "GET", "HEAD", "OPTIONS", "PATCH", "POST", "PUT"].includes(
        method
      )) {
        throw new TypeError(`${method} is not supported.`);
      }
      if (!hasMatchFunction || // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      hasMatchFunction && options.match(parsedURL, request)) {
        const response = await app.inject({
          url: request.url,
          headers: Object.fromEntries(request.headers.entries()),
          payload: Buffer.from(await request.arrayBuffer()),
          method
        });
        const headers = new import_undici.Headers();
        for (const [key, values] of Object.entries(response.headers)) {
          if (values === void 0) {
            continue;
          } else if (Array.isArray(values)) {
            for (const value of values) {
              headers.set(key, value);
            }
          } else {
            headers.set(key, `${values}`);
          }
        }
        const statusText = response.statusMessage;
        const status = response.statusCode;
        const payload = await decompressPayload(response.rawPayload, headers);
        return new import_undici.Response(payload, {
          headers,
          statusText,
          status
        });
      } else {
        return await (options.fetch ?? import_undici.fetch)(request);
      }
    }
  );
});

// src/index.ts
var src_default = fastifyFetch;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  fastifyFetch
});
//# sourceMappingURL=index.cjs.map
